<?php

namespace Drupal\decoupled_pages\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\decoupled_pages\Routing\RoutingEventSubscriber;
use Symfony\Component\HttpFoundation\Request;

/**
 * Serves the standard, empty page for an SPA to attach onto.
 *
 * @internal
 */
class DecoupledPage extends ControllerBase {

  /**
   * Default controller method for a decoupled page.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   *   A Symfony request object.
   *
   * @return array
   *   A render array.
   */
  public function serve(Request $request): array {
    $libraries = $request->attributes->get(RoutingEventSubscriber::DECOUPLED_PAGE_LIBRARIES_ROUTE_DEFAULT_KEY);
    return [
      '#type' => 'page',
      'content' => [
        // @todo: should this ID be configurable?
        '#markup' => '<div id="decoupled-page-root"></div>',
        '#attached' => [
          'library' => $libraries,
        ],
      ],
    ];
  }

}
